#
#  Copyright (c) 2005 Advanced Micro Devices, Inc.
#
#  See the file "license.amd" for information on usage and
#  redistribution of this file, and for a DISCLAIMER OF ALL
#  WARRANTIES.
#
#  RCS: @(#) $Id: module.tcl,v 1.10 2006/09/17 00:57:34 mdejong Exp $
#
#

# Parse tjc module info in the given file

TJC::command module_parse_file tjc.ModuleParseFileCmd
#
#
#
#

# Return name of module file currently being processed

TJC::command module_get_filename tjc.ModuleGetFilenameCmd
#
#
#
#
#
#
#

# Parse tjc module info from the given data buffer.

TJC::command module_parse tjc.ModuleParseCmd
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#

# Parse a single command line. Multiple input lines that were
# continued would have already been compressed by module_parse.

TJC::command module_parse_command tjc.ModuleParseCommandCmd
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#

# Split string up into a list based on spaces.

if {[catch {package require Tcl 8.4} err]} {

# Jacl impl, lacks new regexp command

TJC::command module_space_split tjc.ModuleSpaceSplitCmd
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#

} else {

TJC::command module_space_split tjc.ModuleSpaceSplitCmd2
#
#
#
#
#
#
#

}

# Query current value and expand path pattern out into
# a list of file names.

TJC::command module_expand tjc.ModuleExpandCmd
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#

# Return 1 if the input string looks like a glob pattern.

TJC::command module_looks_like_glob tjc.ModuleLooksLikeGlobCmd
#
#
#
#
#
#
#
#
#
#
#
#


# Query the current value of the given command.

TJC::command module_query tjc.ModuleQueryCmd
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#

# Input is a list of filenames expanded from a SOURCE
# declaration inside a module file and a list of
# filenames expanded from an INCLUDE_SOURCE
# declaration. This method will filter out those
# filenames that appear in the include_source
# from the source list.

TJC::command module_filter_include_source tjc.ModuleFilterIncludeSourceCmd
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#

# Validate options and proc options. If a combination of options
# is not valid, then an error will be raised.

TJC::command module_options_validate tjc.ModuleOptionsValidateCmd
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#

# Validate a single option name and value

TJC::command module_option_validate tjc.ModuleOptionValidateCmd
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#

# Query the value of a specific option. If a proc name is given
# as the second argument then the option for a specific proc
# will be returned.

TJC::command module_option_value tjc.ModuleOptionValueCmd
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#

# Return default value for an option that is not set by the user
# The "dummy" option is just used for testing.

TJC::command module_option_default tjc.ModuleOptionDefaultCmd
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#

# Parse OPTIONS or PROC_OPTION command in a module config file
# and return the list of parsed option names and values.

TJC::command module_options_parse tjc.ModuleOptionsParseCmd
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#

# Return true if the option is actualyl a psudo option
# meaning it enables other options.

TJC::command module_option_is_psudo_option tjc.ModuleOptionIsPsudoOptionCmd
#
#
#
#
#
#

# A psudo option is relaced by specific option flag
# settings, return them here.

TJC::command module_option_replace_psudo_option tjc.ModuleOptionReplacePsudoOptionCmd
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#

# Validate module file data after all of the entries have
# been parsed.

TJC::command module_parse_validate tjc.ModuleParseValidateCmd
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#


